#!/usr/bin/perl

# RoadHog CGI version 1.0
# (c) 2001 Frederik Ramm
# http://www.remote.org/frederik/roadhog/software/
# released under GPL

use CGI;

$mapimgbg = "#ffffee";
$headbg = "#bbbbff";
$navbg = "#ccccaa";

$placeDir = "places/";
$mapDir   = "maps/";
$imageDir = "img/";
$ctlDir =   "control/";
$mrkDir =   "markers/";

$disprows = 5; $dispcols = 5;

$FRAME_NO=0;
$FRAME_TOP=1;
$FRAME_CTRL=2;
$FRAME_JAVA=3;

$query = CGI::new();

# --- language detection code start

my $setlang = $query->param("lang");
my $acceptlang = $ENV{"HTTP_ACCEPT_LANGUAGE"};
my $lang = "en";

if (defined ($acceptlang))
{
	my $de = index ($acceptlang, "de");
	my $en = index ($acceptlang, "en");
	if (($de > -1) && (($en == -1) || ($de < $en)))
	{
		$acceptlang = "de";
	}
	else
	{
		$acceptlang = "en";
	}
}
else
{
	$acceptlang = "en";
}

if ($setlang eq "en")
{
	$carryon{"lang"} = "en" unless ($acceptlang eq "en");
	$appendlang = ".en" unless ($acceptlang eq "en");
	$lang = "en";
} 
elsif ($setlang eq "de")
{
	$carryon{"lang"} = "de" unless ($acceptlang eq "de");
	$appendlang = ".de" unless ($acceptlang eq "de");
	$lang = "de";
}
else
{
	$lang = $acceptlang;
}

if ($lang eq "en")
{
	$word{"faster"} = "faster";
	$word{"slower"} = "slower";
	$word{"pause"} = "pause";
	$word{"continue"} = "continue";
	$word{"forward"} = "forward";
	$word{"back"} = "back";
	$word{"restart"} = "restart";
	$word{"toend"} = "to end";
	$word{'css_no'} = "Do not use CSS";
	$word{'css_yes'} = "Use CSS positioning";
	$word{'frm_no'} = "Do not use Frames";
	$word{'frm_yes'} = "Use Frames";
	$word{'java_no'} = "No Java";
	$word{'java_yes'} = "Use Java";
	$word{'java_err'} = "Your browser doesn't display the Java applet.";
	$word{'frame_err'} = "Your browser doesn't display frames.";
	$word{'frame_err_click'} = "Click here to return to a non-frame version.";
	$word{'title'} = "On the Road in North-West Scotland";
	$word{'placelist'} = "Place List";
	$word{'search'} = "Search";
	$word{'helpfaq'} = "Help &amp; FAQ";
	$word{'problem'} = "Sorry but there seems to be a technical problem. If this condition ".
	  "persists, please contact frederik\@remote.org with a detailed description! ".
	  "A detailed message appears below.";
	$word{'tiny'} = "tiny";
	$word{'small'} = "small";
	$word{'medium'} = "medium";
	$word{'large'} = "large";
	$word{'huge'} = "huge";
	$word{'grid'} = "OSGS Grid";
	$word{'latitude'} = "Latitude";
	$word{'longitude'} = "Longitude";
	$word{'metres'} = "metres";
	$word{'metres-nom'} = "metres";
	$word{'kilometres'} = "kilometres";
	$word{'enterplace'} = "Enter a place name:";
	$word{'examples'} = "Examples";
	$word{'OR'} = "OR";
	$word{'enterloc'} = "Enter a location:";
	$word{'coordmagic'} = "most formats magically recognized, either lat/long according to WGS-84 ".
		"or grid values according to British National Grid";
	$word{'east'} = "East";
	$word{'north'} = "North";
	$word{'mapoff'} = "map off";
	$word{'mapon'} = "show map";
	$word{'mapoffmsg'} = "The map display has been switched off. Use the link in the upper control field ".
	   "to re-activate it.";

}
elsif ($lang eq "de")
{
	$word{"faster"} = "schneller";
	$word{"slower"} = "langsamer";
	$word{"pause"} = "halt";
	$word{"continue"} = "weiter";
	$word{"forward"} = "vor";
	$word{"back"} = "zurck";
	$word{"restart"} = "erstes";
	$word{"toend"} = "ans ende";
	$word{'css_no'} = "Kein CSS";
	$word{'css_yes'} = "CSS-Positionierung";
	$word{'frm_no'} = "Keine Frames";
	$word{'frm_yes'} = "Frames benutzen";
	$word{'java_no'} = "Kein Java";
	$word{'java_yes'} = "Java einschalten";
	$word{'java_err'} = "Ihr Browser zeigt das Java-Applet nicht an.";
	$word{'frame_err'} = "Ihr Browser zeigt keine Frames an.";
	$word{'frame_err_click'} = "Klicken Sie hier, um zu einer Version ohne Frames zurckzukehren.";
	$word{'title'} = "Unterwegs in Nordwestschottland";
	$word{'placelist'} = "Ortsliste";
	$word{'search'} = "Suche";
	$word{'helpfaq'} = "Hilfe &amp; FAQ";
	$word{'problem'} = "Es gibt ein technisches Problem. Wenn diese Meldung wiederholt auftritt, ".
	  "dann melden Sie sich bitte bei frederik\@remote.org mit einer genauen Beschreibung! ".
	  "Eine detaillierte Meldung folgt unten.";
	$word{'tiny'} = "mini";
	$word{'small'} = "klein";
	$word{'medium'} = "mittel";
	$word{'large'} = "gro";
	$word{'huge'} = "riesig";
	$word{'grid'} = "OSGS-Koordinaten";
	$word{'latitude'} = "Lngengrad";
	$word{'longitude'} = "Breitengrad";
	$word{'metres'} = "Metern";
	$word{'metres-nom'} = "Meter";
	$word{'kilometres'} = "Kilometern";
	$word{'enterplace'} = "Geben Sie einen Ortsnamen an:";
	$word{'examples'} = "Beispiele";
	$word{'OR'} = "ODER";
	$word{'enterloc'} = "Geben Sie Koordinaten an:";
	$word{'coordmagic'} = "die meisten Formate werden erkannt, entweder Lnge/Breite nach WGS-84 ".
		"oder British National Grid-Werte";
	$word{'east'} = "Ost";
	$word{'north'} = "Nord";
	$word{'mapoff'} = "karte aus";
	$word{'mapon'} = "karte an";
	$word{'mapoffmsg'} = "Die Kartenansicht wurde abgeschaltet. Benutzen Sie den Link in der oberen Steuerleiste, ".
	   "um sie wieder zu aktivieren.";
}

# -- langauge detection code end
($m_pause, $m_java, $m_css, $sid, $m_frame, $m_new) = decodemode ($query->param("mode"));
$carryon{"mode"} = makemode ($m_pause, $m_java, $m_css, $sid, $m_frame);
$file = $query->param("show");

hacker() unless ($file =~ /^[0-9a-f]{4}(\/[tsmlh]\/\d+)?$/);
my ($ua) = $ENV{HTTP_USER_AGENT};
crawler () if ($ua =~ /crawl/i);
crawler () if ($ua =~ /wget/i);
crawler () if ($ua =~ /spider/i);
crawler () if ($ua =~ /robot/i);

$p_delay = $query->param("delay") || 7;
$carryon{"delay"} = $p_delay;
$initialwait = 10 if ($m_new);

$p_nomap = $query->param("nomap");
$carryon{"nomap"} = $p_nomap if (defined($p_nomap));

$carryon{"show"} = $file;
$p_alt = $query->param("alt") || "0";

($journey, $sizeword, $index) = split (/\//, $file);
$sizeword = "small" if ($sizeword eq "");
$size = substr ($sizeword, 0, 1);
if (length($sizeword) == 1)
{
	my (%smap) = ("s"=>"small", "t" => "tiny", "m" => "medium", "l" => "large", "h"=>"huge" );
	$sizeword = $smap{$sizeword};
}

$index = 1 if ($index == 0);

$journeyfile   = "$ctlDir$journey/$size/control.txt.$lang";

if (($sizeword eq "medium") || ($sizeword eq "large") || ($sizeword eq "huge"))
{
	$markerx = $markery = 40;
	$markerfile = $mrkDir."marker.gif";
}
else
{
	$markerx = $markery = 24;
	$markerfile = $mrkDir."smallmarker.gif";
}
open (JOURNEY, $journeyfile) || trouble ("Cannot find $journey/$size/control.txt.$lang");

# header line
# -----------
$_ = <JOURNEY>;
chomp;
($h_from, $h_to, $h_area, $h_road, $h_count) = split (/:/);
trouble ("Bad format in $journey/$size/control.txt.$lang") if ($index < 1 || $index > $h_count);

# image/map size line
# -------------------
$_ = <JOURNEY>;
chomp;
($imgx, $imgy, $mapname, $mapx, $mapy, $maprows, $mapcols, $maprh, $mapcw) = split (/:/);

# available size class lines - one for maps, one for images
# ---------------------------------------------------------
$avmapsize = <JOURNEY>;
chomp $avmapsize;
$avimgsize = <JOURNEY>;
chomp $avimgsize;
@avsizes = split (/:/, $avimgsize);
for ($i=0; $i < scalar (@avsizes); $i++)
{
	$sizeind{$avsizes[$i]} = $i;
}
# this should create something like
# @avsizes = ("tiny", "small", "medium", "large", "huge");
# %sizeind = ( "tiny" => 0, "small" => 1, "medium" => 2, "large" => 3, "huge" => 4 );

if (!defined ($sizeind{$sizeword}))
{
	trouble ("Bad size format in $journey/$size/control.txt.$lang");
}

$thissize = $sizeind {$sizeword};
if ($thissize < scalar(@avsizes) - 2)
{
	$zoomsizeword = $avsizes[$thissize + 2];
}
elsif ($thissize < scalar(@avsizes) - 1)
{
	$zoomsizeword = $avsizes[$thissize + 1];
}
$zoomsize = substr ($zoomsizeword, 0, 1);

# empty line
# ----------
$_ = <JOURNEY>;
trouble ("Bad format (2) in $journey/$size/control.txt.$lang") unless (/^$/);

# skip lines
for ($count = 0; $count < $index; $count++)
{
	trouble ("$journey/$size/control.txt.$lang: unexpected end of file") unless ($_ = <JOURNEY>);
	trouble ("$journey/$size/control.txt.$lang: unexpected end of file (2)") if (/^$/);
}

chomp;

# this is the line we're interested in
($imgname, $x, $y, $mapfile, $lat, $long, $time, $speed, $heading) = split (/:/);

$next = sprintf ("$journey/$size/%d", $index + 1);

# and there must be one more - see if it is the closing line
trouble ("$journey/$size/control.txt.$lang: unexpected end of file (3)") unless ($_ = <JOURNEY>);

# it is an empty line, so we are at the end of the journey
if (/^$/)
{
	trouble ("$journey/$size/control.txt.$lang: unexpected end of file (4)") unless ($c_where = <JOURNEY>);
	chomp ($c_where);
	while (<JOURNEY>)
	{
		chomp; 
		if (/\.html/)
		{
			$vertexLink = "$placeDir$_";
			last;
		}

		($c_type, $c_prio, $c_detail, $c_heading, $c_road, $c_to, $c_edge, $c_journey) = split (/:/);

		if ($lang eq "en")
		{
			if ($c_heading < 45 || $c_heading > 315)
			{
				$c_dir = "continue";
				$c_dir .= " on the $c_road" if ($c_road ne "");
				$c_dir .= " towards $c_to" if ($c_to ne "");
			}
			elsif ($c_heading < 135)
			{
				$c_dir = "turn right";
				$c_dir .= " onto the $c_road" if ($c_road ne "");
				$c_dir .= " to $c_to" if ($c_to ne "");
			}
			elsif ($c_heading < 180)
			{
				$c_dir = "make a sharp right turn";
				$c_dir .= " onto the $c_road" if ($c_road ne "");
				$c_dir .= " to $c_to" if ($c_to ne "");
			}
			elsif ($c_heading > 225)
			{
				$c_dir = "turn left";
				$c_dir .= " onto the $c_road" if ($c_road ne "");
				$c_dir .= " to $c_to" if ($c_to ne "");
			}
			elsif ($c_heading > 180)
			{
				$c_dir = "make a sharp left turn";
				$c_dir .= " onto the $c_road" if ($c_road ne "");
				$c_dir .= " to $c_to" if ($c_to ne "");
			}
			else
			{
				$c_dir = "return";
				$c_dir .= " along $c_road" if ($c_road ne "");
				$c_dir .= " to $c_to" if ($c_to ne "");
			}
		}
		elsif ($lang eq "de")
		{
			if ($c_heading < 45 || $c_heading > 315)
			{
				$c_dir = "";
				$c_dir .= "auf der $c_road" if ($c_road ne "");
				$c_dir .= " nach $c_to" if ($c_to ne "");
				$c_dir .= " weiterfahren";
			}
			elsif ($c_heading < 135)
			{
				$c_dir = "nach rechts";
				$c_dir .= " auf die $c_road" if ($c_road ne "");
				$c_dir .= " in Richtung $c_to" if ($c_to ne "");
				$c_dir .= " abbiegen";
			}
			elsif ($c_heading < 180)
			{
				$c_dir = "scharf rechts";
				$c_dir .= " auf die $c_road" if ($c_road ne "");
				$c_dir .= " in Richtung $c_to" if ($c_to ne "");
				$c_dir .= " abbiegen";
			}
			elsif ($c_heading > 225)
			{
				$c_dir = "nach links";
				$c_dir .= " auf die $c_road" if ($c_road ne "");
				$c_dir .= " in Richtung $c_to" if ($c_to ne "");
				$c_dir .= " abbiegen";
			}
			elsif ($c_heading > 180)
			{
				$c_dir = "scharf links";
				$c_dir .= " auf die $c_road" if ($c_road ne "");
				$c_dir .= " in Richtung $c_to" if ($c_to ne "");
				$c_dir .= " abbiegen";
			}
			else
			{
				$c_dir = "";
				$c_dir .= "auf der $c_road" if ($c_road ne "");
				$c_dir .= " nach $c_to" if ($c_to ne "");
				$c_dir .= " zurckkehren";
			}
		}

		$c_file = "$c_journey/$size/1";
		if ($c_type eq "d")
		{
			unshift (@connections, { "dir" => $c_dir, "show" => $c_file, "prio" => $c_prio, "detail" => $c_detail });
			$c_default = 1;
		}
		else
		{
			push (@connections, { "dir" => $c_dir, "show" => $c_file, "prio" => $c_prio, "detail" => $c_detail });
		}
	}

	# loop through the connections array lookign for pairs with the same destination
	# (equal journeys) and eliminate one of them if the other is preferred

	$alternatives = 0;

	OUTER:
	while (1)
	{
		for ($i=0; $i<scalar (@connections); $i++)	
		{
			for ($j = $i+1; $j<scalar (@connections); $j++)
			{
				if ($connections[$i]{"dir"} eq $connections[$j]{"dir"})
				{
					if ($connections[$i]{"prio"} < $connections[$j]{"prio"})
					{
						push (@altconn, splice (@connections, $i, 1));
						$alternatives = 1;
						next OUTER;
					}
					elsif ($connections[$j]{"prio"} < $connections[$i]{"prio"})
					{
						push (@altconn, splice (@connections, $j, 1));
						$alternatives = 1;
						next OUTER;
					}
				}
			}
		}
		last OUTER;
	}

	if ($p_alt)
	{
		if ($lang eq "en")
		{
			$message = "<b>$c_where</b> Your <em>standard</em> choices are: ";
		}
		elsif ($lang eq "de")
		{
			$message = "<b>$c_where</b> Die <em>Standard-Auswahlen</em> sind: ";
		}
		$i=0; 
	}
	elsif ($c_default && (!$m_pause) && $p_delay != 0)
	{
		if ($lang eq "en")
		{
			$message = "<b>$c_where</b> If you do not click on anything, you will " .
					$connections[0]{"dir"} . ".";
			$message .= " You can also " if (scalar (@connections) > 1);
		}
		elsif ($lang eq "de")
		{
			$message = "<b>$c_where</b> Wenn Sie nichts anklicken, werden Sie " .
					$connections[0]{"dir"} . ".";
			$message .= " Sie knnen auch " if (scalar (@connections) > 1);
		}
		$next = $connections[0]{"show"};
		$i = 1;
        # make sure that for this one frame, there is enough time for the user
		# to read the message!
		if ($p_delay < 10)
		{
			$p_delay = 10;
		}
		else
		{
			$p_delay += 5;
		}	
	}
	else
	{
		$m_pause = 1;
		$message = "<b>$c_where</b>";
		if (scalar (@connections) == 0)
		{
			# no translation, shouldn't happen anyway
			$message .= " This is a dead end; there are currently no onward journeys from here, ".
				"and not even the return journey has been photographed. Use the link in the bottom ".
				"left corner to go back to the index page.";
		}
		else
		{
			if ($lang eq "en")
			{
				$message .= " You can ";
				$message .= "either " if (scalar (@connections) > 1);
			}
			elsif ($lang eq "de")
			{
				$message .= " Sie knnen ";
				$message .= "entweder " if (scalar (@connections) > 1);
			}
		}
		$i = 0;
	}

	while ($i < scalar (@connections))
	{
		$message .= "<a href=\"" . make_url (\%carryon, { "show" => $connections[$i]{"show"} });
		$message .= "\">" . $connections[$i]{"dir"};
		if ($i < scalar (@connections) - 2) 
		{
			$message .= ",</a> ";
		}
		elsif ($i < scalar (@connections) - 1)
		{
			$message .= ",</a> ";
			$message .= ($lang eq "en") ? "or " : "oder ";
		}
		else
		{
			$message .= ".</a>";
		}
		$i++;
	}

	if ($p_alt && $alternatives)
	{
		if ($lang eq "en")
		{
			$message .= " Your <em>alternative</em> choices are: ";
		}
		elsif ($lang eq "de")
		{
			$message .= " Die <em>alternativen Auswahlen</em> sind: ";
		}
		for ($i=0; $i<scalar (@altconn); $i++)
		{
			$message .= "<a href=\"" . make_url (\%carryon, { "show" => $altconn[$i]{"show"} });
			$message .= "\">" . $altconn[$i]{"dir"};
			if ($altconn[$i]{"detail"})
			{
				$message .= " (".$altconn[$i]{"detail"}.")";
			}
			if ($i < scalar (@altconn) - 2) 
			{
				$message .= ",</a> ";
			}
			elsif ($i < scalar (@altconn) - 1)
			{
				$message .= ",</a> ";
				$message .= ($lang eq "en") ? "or " : "oder ";
			}
			else
			{
				$message .= ".</a>";
			}
		}

	} 
	elsif ($alternatives)
	{
		if ($m_frame != $FRAME_NO)
		{
			$tgt = "target=\"ctlframe\"";
		}
		else 
		{
			$tgt ="";
		}
		if ($lang eq "en")
		{
			$message .= " <font size=-1>(There are <a $tgt href=\"";
			$message .= make_url (\%carryon, { "alt" => "1" });
			$message .= "\">Alternatives.)</a></font>";
		}
		elsif ($lang eq "de")
		{
			$message .= " <font size=-1>(Es gibt <a $tgt href=\"";
			$message .= make_url (\%carryon, { "alt" => "1" });
			$message .= "\">Alternativen.)</a></font>";
		}
	}

}
else
{
	# evaluate this later
	$preloadLine = $_; 

$dummy=<<EOF;
	if ($index == 1)
	{
		if ($lang eq "en")
		{
			$h_road = "road" if ($h_road eq "");
			$message = "This is the start of your journey on the $h_road ";
			$message .= "from <b>$h_from</b> " if ($h_from ne "");
			$message .= "to <b>$h_to";
		}
		elsif ($lang eq "de")
		{
			$h_road = "Strae" if ($h_road eq "");
			$message = "Sie sind am Anfang der Fahrt auf der $h_road ";
			$message .= "von <b>$h_from</b> " if ($h_from ne "");
			$message .= "nach <b>$h_to";
		}
		if ($h_area eq "")
		{
			$message .= ".</b> ";
		}
		else
		{
			$message .= "</b> in $h_area. ";
		}
		$p_delay *= 2;
	}
	else 
EOF
	{
		if ($lang eq "en")
		{
			$h_road = "road" if ($h_road eq "");
			$message = "You are travelling on the $h_road from <b>$h_from</b> to <b>$h_to";
		}
		elsif ($lang eq "de")
		{
			$h_road = "Strae" if ($h_road eq "");
			$message = "Sie fahren auf der $h_road von <b>$h_from</b> nach <b>$h_to";
		}
		if ($h_area eq "")
		{
			$message .= ".</b> ";
		}
		else
		{
			$message .= "</b> in $h_area. ";
		}
	
	#	$percent = $index * 100 / $h_count;
	#	if ($percent > 90)
	#	{
	#		$message .= "You have almost completed the journey.";
	#	} 
	#	elsif ($percent < 15)
	#	{
	#		$message .= "You have only just begun the journey.";
	#	}
	#	elsif ($percent < 36)
	#	{
	#		$message .= "You have completed about a quarter of the journey.";
	#	}
	#	elsif ($percent < 64)
	#	{
	#		$message .= "You are about halfway through the journey.";
	#	}
	#	else
	#	{
	#		$message .= "You have completed about three quarters of the journey.";
	#	} 
			
	}
}
close (JOURNEY);

if (defined ($vertexLink))
{
	if ($lang eq "en")
	{
		$message .= " This place also has a <a target=\"_top\" href=\"$vertexLink$appendlang\">detail page.</a>";
	}
	elsif ($lang eq "de")
	{
		$message .= " Dieser Ort hat auch eine <a target=\"_top\" href=\"$vertexLink$appendlang\">Detailseite.</a>";
	}
}

# the map cell

if ($p_nomap)
{
	$mapcell = "$word{'mapoffmsg'}";
}
else
{
	($centre) = split (/,/, $mapfile);
	$mapfile = ",$mapfile,";
	@rharray = split (/,/, $maprh);
	@cwarray = split (/,/, $mapcw);
	$mapcell ="<table cellspacing=0 cellpadding=0 border=1><tr><td>";
	my ($top, $left) = determineMapDisplay ($centre, $disprows, $dispcols);
	for ($i=0; $i<$top-1;$i++) { $mapyoff += $rharray[$i]; };
	for ($i=0; $i<$left-1;$i++) { $mapxoff += $cwarray[$i]; };
	for ($i = $left; $i < $left+$dispcols; $i++) { $mapenum .= ",".$cwarray[$i-1]; };
	for ($i = $top; $i < $top+$disprows; $i++)
	{
		$mapheight += $rharray[$i-1];
		$mapenum .= ",".$rharray[$i-1];
		for ($j = $left; $j < $left+$dispcols; $j++)
		{
			$mapwidth += $cwarray[$j-1] if ($i==$top);
			$mappart = $i."x".$j;
			$fullpath = "$mapDir$mapname/$size/$mappart";
			if ((!$m_css) && ($mapfile =~ /,$mappart,/))
			{
				$fullpath .= "+$x" . "x" . $y ;
			}
			$alreadyPreloaded{$fullpath} = 1;
			$mapcell .= "<img src=\"$fullpath";
			$mapcell .= sprintf (".gif\" width=%d height=%d>", $cwarray[$j-1], $rharray[$i-1]);
			$mapenum .= ",$mappart";
		}
		$mapcell .= "<br>" unless ($m_css && ($i == $top+$disprows-1));
	}

	if ($m_css)
	{

		$mheading = int (($heading / 30 + 0.5)) * 30;
		$mheading -= 360 if ($mheading > 330);
		$markerfile = sprintf("$mrkDir$size/ar%03d.gif", $mheading);
		if ($sizeword eq "large")
		{
			$markerx=$markery = 18;
		} 
		elsif ($sizeword eq "medium")
		{
			$markerx = $markery = 14;
		}
		else
		{
			$markerx = $markery = 11;
		}
		
		# we can use the simpler absolute positioning if we're in a frame of our own.
		if ($m_frame ne $FRAME_NO)
		{
			$mapcell = "<span style=\"position: absolute; top: 5; left: 5;\">" . $mapcell;
			$newx = $x-$mapxoff-$markerx/2;
			$newy = $y-$mapyoff-$markery/2;
			$mapcell .= "<span style=\"position: absolute; top: $newy; left: $newx;\">";
		}
		else
		{
			#$newx = $x-$mapxoff-$mapwidth-$markerx/2;
			#$newy = $y-$mapyoff-$mapheight+$markery/2;
			$newx = $x-$mapxoff-$mapwidth-$markerx/2;
			$newy = $y-$mapyoff-$mapheight+$markery/2;
			$mapcell .= "<span style=\"position: relative; top: $newy; left: $newx;\">";
		}
		$mapcell .= "<img src=\"$markerfile\"></span>";
	}

	$mapcell .= "</td></tr></table>";
}
#elsif (($maprows == 1) && ($mapcols == 1))
#{
#	$mapcell = "<img src=\"img/maps/$mapname/$size/full.gif\" width=$mapx height=$mapy>";
#}
# ------------------- map cell end -------------


# determine which images to preload for the frame after this.
# if we're at the end of a journey, determine preloads for the first image of all
# onward journeys, otherwise only for the next frame in the current journey.
#
if (($m_frame == $FRAME_CTRL) || ($m_frame == $FRAME_NO))
{
	$preloadcode = "// harmless preload function, won't hurt if javascript off or unavailable\n";
	$preloadcode .= "function preload() {\n   if (document.images) {\n";
	if ($index == $h_count)
	{
		foreach $conn (@connections)
		{
			$preloadcode .= determinePreloadFromFile (%{$conn}->{show});
		}
	}
	else
	{
		# so we are not at the end of the journey. 
		# parse the "look-ahead" line we just read to allow for image pre-loading.
		($pimg, $px, $py, $pmap, $dummy) = split (/:/, $preloadLine);
		$preloadcode .= determinePreload ($imgx, $imgy, $px, $py, $journey, $size, $pimg, $pmap, $maprh, $mapcw);
	}
	$preloadcode .= "   }\n}";
}
# --------------- preloadcode end ----------

# print  "HTTP/1.0 200 OK\n"; (nph only)
print  "Content-type: text/html\n";

# print refresh header if appropriate. in frame mode, only the control frame refreshes.
if (($p_delay > 0) && (!$m_pause) && ($m_frame == $FRAME_CTRL || $m_frame == $FRAME_NO))
{
	printf "Refresh: %d; url=%s\n", $p_delay + $initialwait, make_url (\%carryon, { "show" => $next });
}
if (($p_delay > 0) && (!$m_pause) && ($m_frame == $FRAME_TOP || $m_frame == $FRAME_NO))
{
	$title = ($lang eq "en") ? "You are driving." : "Sie fahren.";
}
else
{
	$title = ($lang eq "en") ? "You have stopped." : "Sie haben angehalten.";
}
print "\n";

printHtmlHeader ($title, ($m_frame == $FRAME_NO) ? $preloadcode : "");

$header = "<font size=+2><b>$word{'title'}</b></font>";

if ((!$m_pause) && ($p_delay > 0))
{
	
	# find enclosing bracket for any speed currently set
	$faster = $slower = $p_delay;
	foreach $allowed (2, 5, 7, 10, 15, 20)
	{
		if ($p_delay < $allowed)
		{
			$slower = $allowed;
			last;
		} 
		elsif ($p_delay > $allowed)
		{
			$faster = $allowed;
		}
	}
	if ($p_delay < $slower)
	{
		$navleft .= "<a href=\"" . make_url (\%carryon, { "delay" => $slower }) . "\">[$word{'slower'}]</a>";
	}
	else
	{
		$navleft .= "[$word{'slower'}]";
	}
	if ($m_frame != $FRAME_NO)
	{
		$navleft .= "&nbsp;<a target=\"_top\" href=\"" . make_url (\%carryon, { "mode" => makemode (1, $m_java, $m_css, $sid, $FRAME_TOP) }) . "\">[$word{'pause'}]</a>&nbsp;";
	}
	else
	{
		$navleft .= "&nbsp;<a href=\"" . make_url (\%carryon, { "mode" => makemode (1, $m_java, $m_css, $sid, $m_frame) }) . "\">[$word{'pause'}]</a>&nbsp;";
	}
	if ($p_delay > $faster)
	{
		$navleft .= "<a href=\"" . make_url (\%carryon, { "delay" => $faster }) . "\">[$word{'faster'}]</a>";
	}
	else
	{
		$navleft .= "[$word{'faster'}]";
	}

} 
else
{
	if ($index > 1)
	{
		$first = "$journey/$size/1";
		$previous = sprintf ("$journey/$size/%d", $index - 1);
		$navleft .= "<a href=\"" . make_url (\%carryon, { "show" => $first }) . "\">[$word{'restart'}]</a>";
		$navleft .= "&nbsp;";
		$navleft .= "<a href=\"" . make_url (\%carryon, { "show" => $previous }) . "\">[$word{'back'}]</a>";
	}
	else
	{
		$navleft .= "<font color=gray>[$word{'restart'}]&nbsp;[$word{'back'}]</font>";
	}
	$navleft .= "&nbsp;";
	if ($index < $h_count)
	{
		$last = sprintf ("$journey/$size/%d", $h_count);
		if ($m_frame != $FRAME_NO)
		{
			$navleft .= "<a target=\"_top\" href=\"" . make_url (\%carryon, { "show" => $next, "mode" => makemode (0, $m_java, $m_css, $sid, $FRAME_TOP) });
		}
		else
		{
			$navleft .= "<a href=\"" . make_url (\%carryon, { "show" => $next, "mode" => makemode (0, $m_java, $m_css, $sid, $m_frame) });
		}
		$navleft .= "\">[$word{'continue'}]</a>&nbsp;";
		$navleft .= "<a href=\"" . make_url (\%carryon, { "show" => $next });
		$navleft .= "\">[$word{'forward'}]</a>&nbsp;";
		$navleft .= "<a href=\"" . make_url (\%carryon, { "show" => $last }) . "\">[$word{'toend'}]</a>";
	}
	else
	{
		$navleft .= "<font color=gray>[$word{'continue'}]&nbsp;[$word{'forward'}]&nbsp;[$word{'toend'}]</font>";
	}
}

$navright = "";
foreach $newsizeword (split (/:/, $avmapsize))
{
	$navright .= "&nbsp;" if ($navright ne "");
	$newsize = substr($newsizeword,0,1);
	if ($size ne $newsize)
	{
		if ($m_frame != $FRAME_NO)
		{
			$navright .= sprintf "<a href=\"%s\">", make_url (\%carryon, 
				{ "show" => sprintf ("$journey/$newsize/%d", $index), "mode" => makemode ($m_pause, $m_java, $m_css, $sid, $FRAME_TOP)});
		}
		else
		{
			$navright .= sprintf "<a href=\"%s\">", make_url (\%carryon, 
				{ "show" => sprintf ("$journey/$newsize/%d", $index) });
		}
	}
	else
	{
		$navright .= "<font color=gray>";
	}
	$navright .= "[$word{\"$newsizeword\"}]";
	if ($size ne $newsize)
	{
		$navright .= "</a>";
	}
	else
	{
		$navright .= "</font>";
	}
}

if ($p_nomap)
{
	undef ($carryon{"nomap"});
	$navmid = sprintf ("<a href=\"%s\">[$word{'mapon'}]</a>", 
		make_url (\%carryon, { }));
}
else
{
	$navmid = sprintf ("<a href=\"%s\">[$word{'mapoff'}]</a>", 
		make_url (\%carryon, { "nomap" => "1" }));
}

# ----------------- now define the contents for the three main layout cells ----------

# the image cell

if (defined ($zoomsize))
{
	$imgcell = "<a href=\"$imageDir$journey/$zoomsize/$imgname\" target=\"_new\">";
	$imgcell.="<img align=right border=0 src=\"$imageDir$journey/$size/$imgname\" width=$imgx height=$imgy ";
	if ($lang eq "en")
	{
		$imgcell.= "alt=\"Click on the image to see an enlarged version.\"></a>";
	}
	elsif ($lang eq "de")
	{
		$imgcell.= "alt=\"Auf das Bild klicken fr eine vergrerte Version.\"></a>";
	}
}
else
{
	$imgcell = "<img src=\"$imageDir$journey/$size/$imgname\" width=$imgx height=$imgy>";
}

# the text cell

if ($m_frame != $FRAME_NO)
{
	$tgt = "target=\"_top\"";
}
else 
{
	$tgt ="";
}

$linkleft ="<a $tgt href=\"index.html$appendlang\">$word{'placelist'}</a> &nbsp; <a $tgt href=\"search.cgi?lang=$lang\">$word{'search'}</a> &nbsp; <a $tgt href=\"faq.html$appendlang\">$word{'helpfaq'}</a>";
if ($lang eq "en")
{
	$txtcell = sprintf ("Lat=$lat Long=$long<br>Speed $speed km/h Heading %03d<br>", $heading);
}
elsif ($lang eq "de")
{
	$txtcell = sprintf ("Lnge=$lat Breite=$long<br>Geschw. $speed km/h Richtung %03d<br>", $heading);
}
$txtcell.= gmtime ($time). " GMT";


if ($m_frame != $FRAME_NO)
{
	$tgt = "target=\"ctlframe\"";
}
else 
{
	$tgt ="";
}

# generate CSS yes/no links only if not java
if (!$m_java)
{
	if ($m_css)
	{

		$linkright .= sprintf "<a $tgt href=\"%s\">$word{'css_no'}</a>", 
			make_url (\%carryon, { "mode" => makemode ($m_pause, $m_java, 0, $sid, $m_frame) });
	}
	else
	{
		$linkright .= sprintf "<a $tgt href=\"%s\">$word{'css_yes'}</a>", 
			make_url (\%carryon, { "mode" => makemode ($m_pause, $m_java, 1, $sid, $m_frame) });
	}
	$linkright .= " &nbsp; ";
}

if ($m_frame != $FRAME_NO)
{
	$linkright .= sprintf "<a target=\"_top\" href=\"%s\">$word{'frm_no'}</a>", 
		make_url (\%carryon, { "mode" => makemode ($m_pause, 0, $m_css, $sid, $FRAME_NO) });
}
else
{
	$linkright .= sprintf "<a href=\"%s\">$word{'frm_yes'}</a>", 
		make_url (\%carryon, { "mode" => makemode ($m_pause, $m_java, $m_css, $sid, $FRAME_TOP) });
}
$linkright .= " &nbsp; ";
if ($m_java)
{
	$linkright .= sprintf "<a target=\"_top\" href=\"%s\">$word{'java_no'}</a>",
		make_url (\%carryon, { "mode" =>  makemode ($m_pause, 0, $m_css, $sid, $FRAME_TOP) });
}
else
{
	$tgt = ($m_frame == $FRAME_NO) ? "" : "target=\"_top\"";
	$linkright .= sprintf "<a $tgt href=\"%s\">$word{'java_yes'}</a>",
		make_url (\%carryon, { "mode" => makemode ($m_pause, 1, $m_css, $sid, $FRAME_TOP) });
}


# ----------------- print the main layout components according to layout setting -----

if ($m_frame == $FRAME_NO)
{
	printOutput ();
}
elsif ($m_frame == $FRAME_CTRL)
{
	printControlFrame ();
}
elsif ($m_frame == $FRAME_TOP)
{
	printTopFrame ();
}
elsif ($m_frame == $FRAME_JAVA)
{
	printJavaFrame ();
}


# ------------------------------------------------------------------------------------
# This is where the body ends and the functions begin --------------------------------
# ------------------------------------------------------------------------------------


# Prints the frame that contains the Java applet.
sub printJavaFrame ()
{
	my ($h) = ($mapheight > $imgy) ? $mapheight : $imgy;
	my ($w) = $mapwidth + $imgx + 10;
	print "<body bgcolor=\"#ffffff\">\n";
	print "<applet code=\"org.remote.roadhog.MapApplet\" name=\"MapApplet\" archive=\"roadhog.jar\" width=$w height=$h>";
	my ($parm) = sprintf ("$disprows,$dispcols,%d,%d,$heading,$mapDir$mapname/$size$mapenum", $x-$mapxoff, $y-$mapyoff);
	print "<param name=\"map\" value=\"$parm\">\n";
	print "<param name=\"photo\" value=\"$imageDir$journey/$size/$imgname\">\n";
	if (defined($zoomsize))
	{
		print "<param name=\"zoom\" value=\"$imageDir$journey/$zoomsize/$imgname\">\n";
	}
	print "$word{'java_err'}\n";
	print "</applet>\n</body>\n";
}

# Prints the hidden control frame with javascript commands to build
# the other frames.
sub printControlFrame ()
{
	print "<html><head><script>\n$preloadcode\n";

	$navleft =~ s/a href/a target=\"ctlframe\" href/gi;
	$navmid =~ s/a href/a target=\"ctlframe\" href/gi;
	$message =~ s/a href/a target=\"ctlframe\" href/gi;
	$navright =~ s/a href/a target=\"_top\" href/gi;

	if ($lang eq "en")
	{
		$ll = sprintf "<a target=\"_top\" href=\"%s\">Auf Deutsch</a>", make_url (\%carryon,
			{ "mode" => makemode ($m_pause, $m_java, $m_css, $sid, $FRAME_TOP), "lang" => "de" });
	}
	else
	{
		$ll = sprintf "<a target=\"_top\" href=\"%s\">In English</a>", make_url (\%carryon,
			{ "mode" => makemode ($m_pause, $m_java, $m_css, $sid, $FRAME_TOP), "lang" => "en" });
	}

	$head = <<EOF;
<body bgcolor="$headbg">
<table width=100% cellspacing=0 border=0>
<tr>
<td>
$header
</td>
<td align=right>
$ll
</td>
</tr>
</table></body>
EOF
	print "window.parent.head.document.open();\n";
	print "window.parent.head.document.write(\"";
	$head =~ s/"/\\"/g;
	$head =~ s/\n//g;
	print "$head\");\n";
	print "window.parent.head.document.close();\n";

	$topnav = <<EOF;
<body bgcolor="$navbg">
<table cellpadding=0 cellspacing=0 width=100% bgcolor="$navbg">
<tr>
<td colspan=3>$message<hr></td>
</tr>
<tr>
<td align=left>
$navleft
</td><td>$navmid</td><td align=right>
$navright
</td>
</tr>
</table>
</body>
EOF
	print "window.parent.topnav.document.open();\n";
	print "window.parent.topnav.document.write(\"";
	$topnav =~ s/"/\\"/g;
	$topnav =~ s/\n//g;
	print "$topnav\");\n";
	print "window.parent.topnav.document.close();\n";

	$botnav = <<EOF;
<body bgcolor="$navbg">
<table cellpadding=0 cellspacing=0 width=100% bgcolor="$navbg">
<tr>
<td align=left>
$linkleft
</td>
<td align=right>
$linkright
</td>
</tr>
</table>
</body>
EOF

	print "window.parent.botnav.document.open();\n";
	print "window.parent.botnav.document.write(\"";
	$botnav =~ s/"/\\"/g;
	$botnav =~ s/\n//g;
	print "$botnav\");\n";
	print "window.parent.botnav.document.close();\n";

	print "window.parent.text.document.write(\"";
	$txtcell = "<body bgcolor=\"$mapimgbg\"><font size=-1>$txtcell</font></body>";
	$txtcell =~ s/"/\\"/g;
	$txtcell =~ s/\n//g;
	print "$txtcell\");\n";
	print "window.parent.text.document.close();\n";

	# specifying base href= in frames seems to be required for some browsers,
	# lest they try to load everything inside those frames based on the frame
	# subdir.
	my ($base) = $query->url();

	if (!$m_java)
	{
		print "window.parent.img.document.open();\n";
		print "window.parent.img.document.write(\"";
		$imgcell = "<head><base href=\"$base\"></head><body bgcolor=\"$mapimgbg\">$imgcell</body>";
		$imgcell =~ s/"/\\"/g;
		$imgcell =~ s/\n//g;
		print "$imgcell\");\n";
		print "window.parent.img.document.close();\n";

		print "window.parent.map.document.open();\n";
		print "window.parent.map.document.write(\"";
		$mapcell = "<head><base href=\"$base\"></head><body bgcolor=\"$mapimgbg\">$mapcell</body>";
		$mapcell =~ s/"/\\"/g;
		$mapcell =~ s/\n//g;
		print "$mapcell\");\n";
		print "window.parent.map.document.close();\n";
	}
	else
	{
		my ($z);
		$parm = sprintf ("$disprows,$dispcols,%d,%d,$heading,$mapDir$mapname/$size$mapenum", $x-$mapxoff, $y-$mapyoff);
		if ($p_nomap)
		{
			print "window.parent.map.document.MapApplet.clearMap();\n";
		}
		else
		{
			print "window.parent.map.document.MapApplet.updateMap(\"$parm\");\n";
		}
		if (defined ($zoomsize))
		{
			$z = "$imageDir$journey/$zoomsize/$imgname";
		}
		else
		{
			$z = "null";
		}
		print "window.parent.map.document.MapApplet.updatePhoto(\"$imageDir$journey/$size/$imgname\", \"$z\");\n";
	}

	print "preload();</script></head></html>\n";
}

# Prints the top frameset that establishes all the subframes.
sub printTopFrame ()
{

	my ($mains, $mainf, $framecolw, $framecolh);

	$mainf = ($mapwidth > $imgy) ? $mapheight : $imgy;
	$framecolw = $mapwidth + 40;
	$framecolh = $mapheight + 20;
	$mainf = "*";
	if ($m_java)
	{
		$mains = sprintf ("<frame name=map src=\"%s\" scrolling=no>\n",
			make_url (\%carryon, { "mode" => makemode ($m_pause, $m_java, $m_css, $sid, $FRAME_JAVA) }));
		$mains .= "<frame name=text src=\"frames/textframe.html\">";
		$mainf .= ",70";
	}
	else
	{
		$mains = "<frameset cols=$framecolw,* bgcolor=$mapimgbg>\n";
		$mains .= "<frameset rows=$framecolh,* bgcolor=$mapimgbg>\n";
		$mains .= "<frame name=map src=\"frames/mapframe.html\" scrolling=no>\n";
		$mains .= "<frame name=text src=\"frames/textframe.html\">";
		$mains .= "</frameset>\n";
		$mains .= "<frame name=img src=\"frames/imgframe.html\" scrolling=no>\n";
		$mains .= "</frameset>\n";
	}
	
	print "<frameset rows=45,120,$mainf,40,0\" bgcolor=#ff0000>\n";
	print "<frame name=head src=\"frames/headframe.html\" border=0 noresize scrolling=no frameborder=0 framespacing=0>\n";
	print "<frame name=topnav src=\"frames/topnavframe.html\" scrolling=no border=0 frameborder=0 framespacing=0>\n";
	print $mains;
	print "<frame src=\"frames/botnavframe.html\" name=botnav scrolling=no frameborder=0>\n";
	printf "<frame src=\"%s\" name=ctlframe noresize scrolling=no border=0 frameborder=0 framespacing=0>\n", make_url (\%carryon, { "mode" => makemode ($m_pause, $m_java, $m_css, $sid, $FRAME_CTRL) });
	print "<noframes>$word{'frame_err'}\n";
	sprintf ("<a target=\"_top\" href=\"%s\">$word{'frame_err_click'}</a>", 
		make_url (\%carryon, { "mode" => makemode ($m_pause, 0, $m_css, $sid, $FRAME_NO) }));
	print "</noframes>\n";
	print "</frameset></html>\n";
	
}

# prints the output in standard mode (no frames)
sub printOutput
{
	if ($lang eq "en")
	{
		$ll = sprintf ("<a href=\"%s\">Auf Deutsch</a>", 
			make_url (\%carryon, { "lang" => "de" }));
	}
	else
	{
		$ll = sprintf ("<a href=\"%s\">In English</a>", 
			make_url (\%carryon, { "lang" => "en" }));
	}

print <<EOF;
<body bgcolor="$mapimgbg" onload="preload();">
<table width=100% cellpadding=5>
<tr bgcolor="$headbg"><td><table width=100% cellspacing=0 cellpadding=0 border=0>
<tr>
<td>
$header
</td>
<td align=right>
$ll
</td>
</tr>
</table>
</td></tr></table>
<table width=100%>
<tr bgcolor="$navbg">
<td colspan=2>
<table cellpadding=0 cellspacing=0 width=100%>
<tr>
<td colspan=3>$message<hr></td>
</tr>
<tr>
<td align=left>
$navleft
</td><td>$navmid</td><td align=right>
$navright
</td>
</tr>
</table>
</td>
</tr>
</table>

<table widht=100%>
<tr valign=top bgcolor="$mapimgbg">
<td>
$mapcell
</td><td rowspan=2>
$imgcell
</td>
</tr>

<tr>
<td><font size=-1>
$txtcell
</font>
</td>
</tr>
</table>

<table width=100%>
<tr bgcolor="$navbg">
<td colspan=2>
<table cellpadding=0 cellspacing=0 width=100%>
<tr>
<td align=left>
$linkleft
</td>
<td align=right>
$linkright
</td>
</tr>
</table>
</td>
</tr>
</table>
</body>
</html>
EOF
}

sub trouble {
	my ($msg) = @_;
	print "Content-type: text/html\nTarget: _top\n\n";
	printHtmlHeader ("Problem");
	print <<EOF;
	<body bgcolor="$mapimgbg">
	<table width=100% cellpadding=5>
	<tr bgcolor="$headbg">
	<td>
	<font size=+2><b>$word{'title'}</b></font>
	</td>
	</tr>
	</table>
	<p>
	<table width=100%>
	<tr><td>$word{'problem'}
	<p>
	<tt>$msg</tt>
	</td>
	</tr>
	</table>
	<p>
	<table cellpadding=0 cellspacing=0 width=100% bgcolor="$navbg">
	<tr>
	<td align=left>
	<a href="index.html$appendlang">$word{'placelist'}</a> &nbsp; <a href="search.cgi?lang=$lang">$word{'search'}</a> &nbsp; <a href="faq.html$appendlang">$word{'helpfaq'}</a>
	</td>
	<td align=right>
	v1.0
	</td>
	</tr>
	</table>
	</body>
	</html>
EOF
	exit;
}

# evil people.
sub hacker 
{
	trouble ("Bad CGI parameters.");
}

# evil programs
sub crawler
{
	trouble ("Your User-Agent header indicates that you are a crawler/robot. ".
		"Please do not crawl the CGI scripts. If this is a mistake, contact ".
		"me and I'll make an exception (or change your header to something ".
		"unpretentious).");
}

# creates a new URL with fields from the first hash, superseded by
# fields in the second hash
sub make_url
{
	$hash = $_[0];
	$overwrite = $_[1];
	$rv = "";
	foreach $key (keys (%$hash))
	{
		$rv .= "&" if ($rv ne "");
		#fixme
		$rv .= $key . "=";
		if (defined($$overwrite{$key}))
		{
			$rv .= $$overwrite{$key};
			delete $$overwrite{$key};
		}
		else
		{
			$rv .= $$hash{$key};
		}
	}
	foreach $key (keys (%$overwrite))
	{
		$rv .= "&" if ($rv ne "");
		$rv .= $key . "=" .$$overwrite{$key};
	}
	return $query->script_name ()."?".$rv;
}

# finds out the section of map we're going to show.
sub determineMapDisplay 
{
	my ($preferredCentre, $displayRows, $displayCols) = @_;
	my ($top, $left) = split ("x", $preferredCentre);
	
	$top -= int ($displayCols / 2);
	$top = $maprows - $displayRows + 1 if ($top + $displayRows - 1 > $maprows);
	$top = 1 if ($top < 1);
	$left -= int ($displayCols / 2);
	$left = $mapcols - $displayCols + 1 if ($left + $displayCols - 1 > $mapcols);
	$left = 1 if ($left < 1);

	return ($top, $left);
}
	
# peeks into another journey's control file to find out which files to preload.
sub determinePreloadFromFile 
{
	my ($file) = @_;
	my ($journey, $size, $index) = split (/\//, $file);
	my ($journeyfile) = "$ctlDir$journey/$size/control.txt.$lang";
	open (JX, $journeyfile) || return ();
	<JX>;
	$_ = <JX>;
	chomp;
	my ($imgx, $imgy, $mapname, $mapx, $mapy, $maprows, $mapcols, $maprh, $mapcw) = split (/:/);
	<JX>;
	<JX>;
	<JX>;
	$_ = <JX>;
	my ($imgname, $x, $y, $mapfile, $lat, $long, $time, $speed, $heading) = split (/:/);
	close (JX);
	
	return (determinePreload ($imgx, $imgy, $x, $y, $journey, $size, $imgname, $mapfile, $maprh, $mapcw));
}

# determines preload files from a parsed line in a control file.
sub determinePreload 
{
	my ($imgx, $imgy, $x, $y, $journey, $size, $imgname, $mapfile, $maprh, $mapcw) = @_;

	my ($i, $j, $map);
	my ($preloadcode) = "";
	my ($part, $i, $j, $mapdim);

	$pm++;
	$preloadcode .= "   img$pm = new Image ($imgx,$imgy); img$pm.src=\"$imageDir$journey/$size/$imgname\";\n";

	if (!$p_nomap)
	{
		$part = 0;
		my ($centre) = split (/,/, $mapfile);
		$mapfile = ",$mapfile,";
		@rharray = split (/,/, $maprh);
		@cwarray = split (/,/, $mapcw);
		my ($top, $left) = determineMapDisplay ($centre, $disprows, $dispcols);
		for ($i = $top; $i < $top+$disprows; $i++)
		{
			for ($j = $left; $j < $left+$dispcols; $j++)
			{
				$mapdim = $i."x".$j;
				$map = "$mapDir$mapname/$size/$mapdim";
				if ((!$m_css) && ($mapfile =~ /,$mapdim,/))
				{
					$map .= "+$x" . "x" . $y ;
				}
				next if (defined ($alreadyPreloaded{$map}));
				$alreadyPreloaded{$map} = 1;
				$pm++;
				$preloadcode .= "   img$pm = new Image ($cwarray[$j],$rharray[$i]); img$pm.src=\"${map}.gif\";\n";
			}
		}
	}
	return ($preloadcode);
}

# generates a "mode" code from individual fields.
sub makemode
{
	my ($pause, $java, $css, $sid, $frame) = @_;
	my ($newmode) = ((((((((($pause << 1) | $java) << 1) | 1) << 1) | $css) << 5) | $sid) << 3) | $frame;
	return sprintf ("%03x", $newmode);
}

# parses a "mode" code into individual fields. "mode" is just a 12-bit field expressed as 
# three hex digits. two bits are used as chcksum bits, and five are used for a kind of
# ppor man's session id which is randomly assigned; this is just to assist log searching
# in case of trouble.
sub decodemode
{
	my ($mode) = @_;
	my ($pause, $java, $css, $sid, $frame, $check1, $check2);
	my ($bits) = hex ($mode);
	
	$frame = ($bits & 3);
	$bits >>= 2;
	$check1 = ($bits & 1);
	$bits >>= 1;
	$sid = ($bits & 31);
	$bits >>= 5;
	$css = ($bits & 1);
	$bits >>= 1;
	$check2 = ($bits & 1);
	$bits >>= 1;
	$java = ($bits & 1);
	$bits >>= 1;
	$pause = ($bits & 1);

	if (($check2 != 1) || ($check1 != 0))
	{
		$sid = int (rand (32));
		return (0, 0, 0, $sid, 0, 1);
	}

	return ($pause, $java, $css, $sid, $frame, 0);
}

# prints html header with a little bit of style.
sub printHtmlHeader 
{
	my ($title, $jscode) = @_;
	print <<EOF;
	<html>
	<head>
	<title>On the Road in North-West Scotland: $title</title>
	<script>
	$jscode
	</script>
	<style type="text/css">
	<!--
	body { margin: 2%; background: #ffffee;  color: black; }
	p,td,th,h1,h2,h3,ul,ol,li,b,em,strong.dt,dd,dl { font-family: "New Century Schoolbook", Times, serif; color: black; }
	a:visited { color: #551A8B; }
	a:link { color: #0000EE; }
	//-->
	</style>
	</head>
EOF
	return;
}

